import java.applet.Applet;
import java.awt.Button;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;


public class Reversi extends Applet implements ActionListener, MouseListener
{
	Speelveld speelveld;
	boolean team, voorspellerAan, wasZetMogelijk;
	int diameter, verplaatsing;
	int[][] grafischVeld;
	Label aantalStenen1, aantalStenen2, spelStatus;
	
	public void init()
	{
		//De hoogte en breedte uit het HTML-file halen en controleren...
		int aantalVakkenX, aantalVakkenY;
		String aVakkenXString, aVakkenYString;
		aVakkenXString = getParameter("breedte");
		if(aVakkenXString == null || Integer.parseInt(aVakkenXString)<3)
			aantalVakkenX = 6;
		else
			aantalVakkenX = Integer.parseInt(aVakkenXString);
		aVakkenYString = getParameter("hoogte");
		if(aVakkenYString == null || Integer.parseInt(aVakkenYString)<3)
			aantalVakkenY = 6;
		else
			aantalVakkenY = Integer.parseInt(aVakkenXString);
		
		//variabelen hun eerste waarde geven en een speelveld maken (dmv de methode maakSpeelveld
		diameter = 40;
		verplaatsing = 25;
		maakSpeelveld(aantalVakkenX, aantalVakkenY);
		
		//Layouttoestanden organiseren
		this.setLayout(null);
		Panel controls = new Panel();
		controls.setBounds((diameter*aantalVakkenX)+75, 25, 200, 200);
		controls.setLayout(new GridLayout(5, 1, 5, 5));
		this.add(controls);
		
		//de knoppen definieren
		Button nieuwSpel, help;
		nieuwSpel = new Button("Nieuw spel");
		help = new Button("Help");
		controls.add(nieuwSpel);
		controls.add(help);
		nieuwSpel.addActionListener(this);
		help.addActionListener(this);
		
		
		//De labels initialiseren
		aantalStenen1 = new Label("Aantal stenen van blauw  = ");
		aantalStenen2 = new Label("Aantal stenen van rood  = ");
		spelStatus = new Label("Spel is aan het starten");
		controls.add(aantalStenen1); controls.add(aantalStenen2); controls.add(spelStatus);
		
		//mouselistener definieren
		this.addMouseListener(this);
	}
	
	public void maakSpeelveld(int aantalVakkenX, int aantalVakkenY)
	{
		//het eerste team (blauw) een beurt geven en de help-functie standaard uitzetten
		team = true;
		voorspellerAan = false;
		
		//een speelveld object creeren
		speelveld = new Speelveld(aantalVakkenX, aantalVakkenY);
		
		wasZetMogelijk = true;
	}
	
	public void paint(Graphics g)
	{
		tekenVeld(g, speelveld.veld.length, speelveld.veld[0].length, verplaatsing);
		tekenSituatie(g, speelveld.veld.length, speelveld.veld[0].length, verplaatsing);
		spelStatusControle();
	}
	
	public void spelStatusControle()
	{
		this.aantalStenen1.setText("Aantal stenen van blauw = " + speelveld.aantalStenen1);
		this.aantalStenen2.setText("Aantal stenen van rood = " + speelveld.aantalStenen2);
		if(team)
		{
			spelStatus.setText("Blauw is aan zet");
		}
		if(!team)
		{
			spelStatus.setText("Rood is aan zet");
		}
		if(speelveld.aantalStenen1 <= speelveld.aantalStenen2 && speelveld.maxAantalStenen == (speelveld.aantalStenen1 + speelveld.aantalStenen2))
		{
			spelStatus.setText("Rood heeft gewonnen");
		}
		if(speelveld.aantalStenen1 >= speelveld.aantalStenen2 && speelveld.maxAantalStenen == (speelveld.aantalStenen1 + speelveld.aantalStenen2))
		{
			spelStatus.setText("Blauw heeft gewonnen");
		}
		if(!speelveld.zetMogelijk)
		{
			if(!wasZetMogelijk)
			{
				spelStatus.setText("Remise");
			}
			else
			{
				wasZetMogelijk = false;
				spelStatus.setText("Je moest passen");
			}
		}
	}
	
	public void tekenVeld(Graphics g, int aantVakkenX, int aantVakkenY, int verplaatsing)
	{
		//Tekent het reversi speelbord met een hoogte aantal verticale vakken en 
		//een breedte aantal verticale vakken
		int tX, tY;
		for(tY=0; tY<aantVakkenX; tY++)
		{
			for(tX=0; tX<aantVakkenY; tX++)
			{
				g.drawRect((diameter*tY) + verplaatsing, (diameter*tX) + verplaatsing, diameter, diameter);
			}
		}
	}
	
	public void tekenSteen(Graphics g, int vakx, int vaky, int verplaatsing)
	{
		g.fillOval(((diameter*vakx)+1)+verplaatsing, ((diameter*vaky)+1)+verplaatsing, diameter-1, diameter-1);
	}
	
	public int[] converteerVeld(double muisx, double muisy, int diameter, int verplaatsing)
	{
		//de array vakxy slaat in de volgorde x, y op in welk vak er wordt geklikt
		int[] vakxy;
		vakxy = new int[2];
		vakxy[0] = (int) (muisx - verplaatsing)/diameter;
		vakxy[1] = (int) (muisy - verplaatsing)/diameter;
		return vakxy;
	}
	
	public void tekenSituatie(Graphics g, int aantalVeldenX, int aantalVeldenY, int verplaatsing)
	{
		int tX, tY;
		for(tX=0; tX<speelveld.veld.length; tX++)
		{
			for(tY=0; tY<speelveld.veld[0].length; tY++)
			{
				if(speelveld.veld[tX][tY]==1)
				{
					g.setColor(Color.BLUE);
					this.tekenSteen(g, tX, tY, verplaatsing);
				}
				else if(speelveld.veld[tX][tY]==2)
				{
					g.setColor(Color.RED);
					this.tekenSteen(g, tX, tY, verplaatsing);
				}
				else if(speelveld.veld[tX][tY]==3 && voorspellerAan)
				{
					g.setColor(Color.GRAY);
					this.tekenSteen(g, tX, tY, verplaatsing);
				}
			}
		}
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(((Button)e.getSource()).getLabel() == "Help")
		{
			voorspellerAan = !voorspellerAan;
			this.repaint();
		}
		if(((Button)e.getSource()).getLabel() == "Nieuw spel")
		{
			this.maakSpeelveld(speelveld.veld[0].length, speelveld.veld.length);
			this.repaint();
		}
	}
	public void mousePressed(MouseEvent e)
	{
		
	}
	public void mouseReleased(MouseEvent e)
	{
		
	}
	public void mouseClicked(MouseEvent e)
	{
		int[] vakxy;
		vakxy = this.converteerVeld(e.getX(), e.getY(), diameter, verplaatsing);
		try
		{
			boolean verwerkZetOK = speelveld.verwerkZet(vakxy[0], vakxy[1], team, voorspellerAan);
			if(verwerkZetOK)
			{			
				team = !team;
			}
		}
		catch(Exception ex)
		{
			
		}
		this.repaint();	
	}
	public void mouseEntered(MouseEvent e)
	{
		
	}
	public void mouseExited(MouseEvent e)
	{
		
	}
}
