
public class Speelveld 
{
	int[][] veld, aansluitRichtingen;
	int aantalStenen1, aantalStenen2, maxAantalStenen;
	boolean zetMogelijk;
	
	public Speelveld(int aantalVeldenX, int aantalVeldenY)
	{
		//er wordt een tabel gemaakt met daarin een model van het veld
		//0=leeg, 1=rood(a), 2=blauw(b)
		int tX, tY;
		veld = new int[aantalVeldenX][aantalVeldenY];
		aansluitRichtingen = new int[8][3];
		for(tX=0; tX<veld.length; tX++)
		{
			for(tY=0; tY<veld[0].length; tY++)
			{
				veld[tX][tY]=0;
			}
		}
		veld[(veld.length/2)-1][(veld[0].length/2)-1]=1;
		veld[(veld.length/2)-1][(veld[0].length/2)]=2;
		veld[(veld.length/2)][(veld[0].length/2)-1]=2;
		veld[(veld.length/2)][(veld[0].length/2)]=1;
		
		//Vervolgens de integers hun eerste waarde geven.
		aantalStenen1= aantalStenen2 = 2;
		maxAantalStenen = veld.length * veld[0].length;
		zetMogelijk=true;
		
		//De eerste keer geldige zetten klaarzetten
		for(tY=0; tY<veld.length; tY++)
		{
			for(tX=0; tX<veld[0].length; tX++)
			{
				boolean zetOK;
				zetOK = controleerZet(tX, tY, 1, 2);
				if(zetOK)
				{
					veld[tX][tY] = 3;
				}
				else if(!zetOK && !(veld[tX][tY]==1 || veld[tX][tY]==2)) //zetOK is dus false
				{
					veld[tX][tY] = 0;
				}
			}
		}
	}
	
	public boolean controleerZet(int veldX, int veldY, int speler, int tegenstander)
	{
		//Deze methode kijkt of een zet geldig is en sluit de stenen in de geldige
		//richtingen meteen aan. Vervolgens retourneert hij een array met goed of fout
		//en de aangepaste array.
		int dY, dX;
		boolean slagMogelijk = false;
		
		//Deze if kijkt of het vak waarop geklikt is wel leeg is.
		if(veld[veldX][veldY]!= 1 || veld[veldX][veldY]!=2)
		{
			//Deze dubbele forloop kijkt in alle 8 richtingen, plus voor zowel x als y in
			//richting 0,0. Dan gebeurt er gewoon niks van er wordt dan steeds gekeken naar
			//het huidige vak, want veldX+(0*t) is altijd veldX, en hetzelfde geldt voor
			//vakY. Dit betekent alleen dat er een keer extra wordt gerekend en dat maakt
			//niet zo uit aangezien dit geen rekenintensief algoritme is.
			int aansluitRichtingenArrayIndex = 0;
			aansluitRichtingen = new int[8][3];
			for(dX=-1; dX <= 1; dX++)
			{
				for(dY=-1; dY <= 1; dY++)
				{
					//Er moet een try-catch constructie aanwezig zijn, want dit algoritme
					//probeert plaatsen op negatieve array-indices vragen of juist heel
					//grote niet-bestaande array-indices vragen.
					try
					{
						//Controle of er in een aangrenzend vak wel een tegenstander is.
						//Dit voorkomt tevens een klik in vakje zonder stenen in de
						//omringende vakken.
						if(veld[veldX+dX][veldY+dY]==tegenstander && !(dX==0 && dY==0))
						{
							//hoever is een variabele die aangeeft tot hoever er in deze
							//richting gezocht moet worden tot er weer een steen van de
							//huidige speler wordt gevonden na een ononderbroken reeks
							//stenen van de tegenstander. Standaard is dit 0, omdat dan
							//nooit kan worden aangesloten als er iets mis mocht gaan met de
							//boolean slagMogelijkInRichting. Tevens moet hij toch een 
							//waarde krijgen om de compiler te vriend te houden.
							boolean slagMogelijkInRichting = false;
							int hoever = 0;
													
							for(hoever=1; hoever<(veld.length+veld[0].length) && !slagMogelijkInRichting; hoever++)
							{
								//Wanneer in na onderstaande controle (die controleert of er
								//in deze richting ononderbroken stenen van de tegenstander
								//staan en aan het eind van zon ononderbroken reeks een steen
								//van de huidige speler.
								if(veld[veldX+(dX*hoever)][veldY+(dY*hoever)]==speler)
								{
									slagMogelijk = slagMogelijkInRichting = true;															
								}
							}
							if(slagMogelijkInRichting)
							{
								aansluitRichtingen[aansluitRichtingenArrayIndex][0] = dX;
								aansluitRichtingen[aansluitRichtingenArrayIndex][1] = dY;
								aansluitRichtingen[aansluitRichtingenArrayIndex][2] = hoever-1;								
							}
							else
							{
								aansluitRichtingen[aansluitRichtingenArrayIndex][0] = 0;
								aansluitRichtingen[aansluitRichtingenArrayIndex][1] = 0;
								aansluitRichtingen[aansluitRichtingenArrayIndex][2] = 0;								
							}
							aansluitRichtingenArrayIndex++;													
						}
					}
					catch(Exception e)
					{
						//Er wordt nu hoogstwaarschijnlijk gevraagt naar een array-index
						//die buiten de array ligt, zoals [-1] of [veld.length+1].
						//We hoeven hierop geen actie te ondernemen, maar er alleen voor te
						//zorgen dat de applet niet stopt.
					}
				}
			}
		}
		//slagMogelijk heeft alleen maar true kunnen zijn, als aan alle andere voorwaarden
		//al is voldaan. slagMogelijk geeft dus ook aan of de zet uiteindelijk mogelijk was.
		return slagMogelijk;
	}
	
	public int[] converteerTeam(boolean teamAanZet)
	{
		int[] spelerTegenstander = new int[2];
		if(teamAanZet)
		{
			spelerTegenstander[0] = 1;
			spelerTegenstander[1] = 2;
		}
		else //teamAanZet is dus false
		{
			spelerTegenstander[0] = 2;
			spelerTegenstander[1] = 1;
		}
		return spelerTegenstander;
	}
	
	public boolean verwerkZet(int veldX, int veldY, boolean teamAanZet, boolean voorspellerAan)
	{
		int speler, tegenstander;
		speler = converteerTeam(teamAanZet)[0];
		tegenstander = converteerTeam(teamAanZet)[1];
		
		//Het veld klaarzetten in lege vakken en vakken met een mogelijke zet.
		int tX, tY;
		if(veld[veldX][veldY] == 3)
		{
			//De zet uitvoeren en stenen slaan.
			controleerZet(veldX, veldY, speler, tegenstander); //Dit om een goede richtingenarray te krijgen.
			sluitStenenAan(veldX, veldY, speler, tegenstander);
			
			for(tY=0; tY<veld.length; tY++)
			{
				for(tX=0; tX<veld[0].length; tX++)
				{
					boolean zetOK;
					//Speler en tegenstander omdraaien omdat dit voor de volgende zet is.
					zetOK = controleerZet(tX, tY, tegenstander, speler);
					if((veld[tX][tY]!=1 && veld[tX][tY]!=2) && zetOK)
					{
						veld[tX][tY] = 3;						
					}
					else if((veld[tX][tY]!=1 && veld[tX][tY]!=2) && !zetOK) //zetOK is dus false
					{
						veld[tX][tY] = 0;
					}
				}
			}
			stenenTellen();
			return true;
		}
		return false;
	}
	
	public void sluitStenenAan(int veldX, int veldY, int speler, int tegenstander)
	{
		int t1, t2;
		veld[veldX][veldY] = speler;
		for(t1=0; t1<aansluitRichtingen.length; t1++)
		{
			int dX, dY, hoever;
			dX = aansluitRichtingen[t1][0];
			dY = aansluitRichtingen[t1][1];
			hoever = aansluitRichtingen[t1][2];			
			if(!(dX==0 && dY==0))
			{
				for(t2=1; t2<=hoever; t2++)
				{					
					veld[veldX+(dX*t2)][veldY+(dY*t2)] = speler;
				}
			}
		}
	}
	
	public void stenenTellen()
	{
		int tX, tY;
		aantalStenen1 = aantalStenen2 = 0;
		int aantalZetten = 0;
		for(tX=0; tX<veld.length; tX++)
		{
			for(tY=0; tY<veld[0].length; tY++)
			{
				if(veld[tX][tY]==1)
				{
					aantalStenen1++;
				}
				if(veld[tX][tY]==2)
				{
					aantalStenen2++;
				}
				if(veld[tX][tY]==3)
				{
					aantalZetten++;
				}
			}
		}
		if(aantalZetten==0)
		{
			zetMogelijk=false;
		}
	}
}

//nodig in noodgevallen:
//System.out.println(""+t);